
function jsnippets_onload(e) {
  if (typeof jsnippets_get_all != 'undefined') {
    var s = jsnippets_get_all();
    jsnippets_add_selects(s);
  }
}

function jsnippets_add_selects(jsnippets) {
  var acdb = [];

  for (var id in jsnippets) {
    var select = jsnippets_add_select($(id), jsnippets[id], 'jsnippet-' + id);
    // URL needs to be fixed or manually amended.
    new jsnippet(select, $(id), new ACDB('/jsnippets/retrieve'));
  }
}

function jsnippets_add_select(textarea, jsnippet, jsnippet_id) {
  var div = document.createElement('div');
  addClass(div, 'jsnippet');
  div.id = jsnippet_id;
  var select = div.appendChild(document.createElement('select'));
  for (var o in jsnippet) {
    var opt = select.appendChild(document.createElement('option'));
    opt.value = o;
    opt.innerHTML = jsnippet[o];
  }
  document.body.appendChild(div);
  p = absolutePosition(textarea);
  $(jsnippet_id).style.left = (p.x + textarea.clientWidth - $(jsnippet_id).clientWidth) + 'px';
  $(jsnippet_id).style.top = (p.y - $(jsnippet_id).clientHeight) + 'px';

  return select;
}

function jsnippet(select, textarea, db) {
  var snip = this;
  this.input = select;
  addClass(this.input, 'form-autocomplete');
  this.textarea = textarea;
  this.db = db;
  this.db.owner = this;
  this.input.onchange = function (event) {
    snip.search(this.value);
  }
}

jsnippet.prototype.search = function (str) {
  if (str != 'none') {
    this.db.owner = this;
    this.str = str;
    this.db.search(str);
  }
}

jsnippet.prototype.found = function (matches) {
  removeClass(this.input, 'throbbing');
  this.insert(matches[this.str]);
}

jsnippet.prototype.insert = function (match) {
  if (this.textarea.value.length > 0) {
    this.textarea.value += '\n\n' + match;
  }
  else {
    this.textarea.value = match;
  }
  this.textarea.scrollTop = this.textarea.scrollHeight - this.textarea.clientHeight;
}

if (isJsEnabled()) {
  addLoadEvent(jsnippets_onload);
}
